# Real Bots release 1.0.0 by Steven Hartin
# ./addons/eventscripts/realbots/realbots.py

# >>> To configure this addon please see config.cfg <<<

#################################
#### DO NOT EDIT THIS FILE, #####
####    IF YOU DO, THINGS   #####
####       COULD BREAK      #####
#################################

import es
import os
import random
import playerlib
import gamethread

from configobj import ConfigObj
from string import Template

# psyco, more unstable but a lot faster
import psyco
psyco.full() 

# Set the addon info data
info = es.AddonInfo()
info.name = 'Real Bots'
info.version = '1.0.0'
info.url = 'http://addons.eventscripts.com/addons/view/realbots'
info.basename = 'realbots'
info.author = 'Freddukes AKA Pro Noob'

# Make Public Variable
es.ServerVar('realbots_version', info.version, 'Real Bots Version - Made by Freddukes').makepublic()

class LoadError(Exception):
    """ Class to allow a custom raise error """
    pass

class BotManager(object):
    """  """
    
    templates   = {}
    bots        = {}
    botCount    = 0
    unusedNames = []
    usedNames   = []
    sayEvents   = ConfigObj(es.getAddonPath('realbots') + "/bot_speech.ini")
    
    def __init__(self):
        """  """
        self.botprofile = str(es.ServerVar('eventscripts_gamedir')).replace('\\','/') + "/botprofile.db"
        self.directory  = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').split('/')[-1]
        
        if self.directory == "cstrike":
            self.botAdd        = "bot_add"
            self.playerManager = es.getentityindex('cs_player_manager')
            
        elif self.directory == "tf":
            self.botAdd = "bot"
            self.playerManager = es.getentityindex('tf2_player_manager')
            
        elif self.directory == "hl2mp":
            self.botAdd = "bot_add"
            self.playerManager = es.getentityindex('player_manager')
            
        else:
            raise LoadError, "The game %s is not supported" % es.getgame()
            es.unload('realbots')
            
    def createTemplate(self, templateType, name, skill=None, agression=None, reactionTime=None, difficulty="NORMAL", pitch=90, weaponPreference=None):
        """  """
        if templateType.lower() == "skill":
            if difficulty.upper() not in ("EASY", "NORMAL", "HARD", "EXPERT"):
                difficulty = "NORMAL"
            self.templates[name] = {'Type':'skill', 'Skill':skill, 'Aggression':agression, 'ReactionTime':reactionTime, 'Difficulty':difficulty.upper(), 'VoicePitch':pitch}
        elif templateType.lower() == "weapon":
            if isinstance(weaponPreference, str):
                weaponPrefence = (weaponPreference,)
            self.templates[name] = {'Type':'weapon', 'WeaponPreference': weaponPreference}
            
    def createBot(self, skillTemplate, weaponTemplate, name, skin=1, pitch=90):
        """  """
        self.bots[name] = {'skillTemplate':skillTemplate, 'weaponTemplate':weaponTemplate, 'skin':skin, 'pitch':pitch}
        self.unusedNames.append(name)
    
    def deleteBot(self, name):
        """  """
        if name:
            del self.bots[name]
        self.removeBot(name)
        if name in self.usedNames:
            self.usedNames.remove(name)
        if name in self.unusedNames:
            self.unusedNames.remove(name)
            
    def addBot(self, name=None):
        """  """
        if self.botCount < int(es.ServerVar('rb_botAmount')):
            if not name:
                name = random.choice(self.unusedNames)
            if not name in map(lambda x: es.getplayername(x), filter(lambda x: es.isbot(x), es.getUseridList() ) ):
                es.server.queuecmd('%s "%s"' % (self.botAdd, name) )
                self.botCount += 1
                if name in self.unusedNames:
                    self.unusedNames.remove(name)
                if name not in self.usedNames:
                    self.usedNames.append(name)
                if self.botCount == 1:
                    if int(es.ServerVar('rb_ping')):
                        gamethread.delayedname(float(es.ServerVar('rb_pingUpdateDelay') ), 'botPing', self.updatePing)
                        self.updateBotCount
            else:
                self.addBot()
        
    def removeBot(self, name=None):
        """  """
        if not name:
            name = es.getplayername(random.choice(filter(lambda x: es.isbot(x), es.getUseridList() ) ) )
        if name in map(lambda x: es.getplayername(x), filter(lambda x: es.isbot(x), es.getUseridList() ) ):
            es.server.queuecmd('kick "%s"' % name)
            self.botCount -= 1
            if name in self.usedNames:
                self.usedNames.remove(name)
            if name not in self.unusedNames:
                self.unusedNames.append(name)
            if not self.botCount:
                gamethread.cancelDelayed('botPing')
                gamethread.cancelDelayed('updateBotCount')
        else:
            self.removeBot()
        
    def removeAllBots(self):
        for bot in map(lambda x: es.getplayername(x), filter(lambda x: es.isbot(x), es.getUseridList() ) ):
            self.removeBot(bot)
        
    def command(self, command, playerlist=[]):
        """  """
        if not playerlist:
            playerlist = filter(lambda x: es.isbot(x) and not es.getplayerprop(x,'CBasePlayer.pl.deadflag'), es.getUseridList() )
        for bot in playerlist:
            es.server.queuecmd(command)
        
    def updatePing(self):
        """  """
        for player in playerlib.getPlayerList('#bot'):
            es.setindexprop(self.playerManager, "CPlayerResource.m_iPing.%03d" % player.get('index'), (random.randint(int(es.ServerVar('rb_minPing')), int(es.ServerVar('rb_maxPing') ) ) ) )
        gamethread.delayedname(float(es.ServerVar('rb_pingUpdateDelay') ), 'botPing', self.updatePing)
        
    def updateBotCount(self):
        self.botCount = len(filter(lambda x: es.isbot(x), es.getUseridList()))
        gamethread.delayedname(5, 'updateBotCount', self.updateBotCount)
        
    def execute(self):
        """  """
        thisFile = open(self.botprofile, 'r')
        tempStr  = ""
        tempStr += """\
//----------------------------------------------------------------------------
// BotProfile.db
// Author: Freddukes (-TsX- Pro Noob)
//
// This database defines bot "personalities". 
// Feel free to edit it and define your own bots.
//


//----------------------------------------------------------------------------

//
// All profiles begin with this data and overwrite their own
//
Default
	Skill = 50
	Aggression = 50
	ReactionTime = 0.3
	AttackDelay = 0
	Teamwork = 75
	WeaponPreference = none
	Cost = 0
	Difficulty = NORMAL
	VoicePitch = 100
	Skin = 0
End

//----------------------------------------------------------------------------

//
// These templates inherit from Default and override with their values
// The name of the template defines a type that is used by individual bot profiles
//

//----------------------------------------------------------------------------
// weapon preference templates
//----------------------------------------------------------------------------
"""
        for template in filter(lambda x: self.templates[x]["Type"] == "weapon", self.templates):
            tempStr += 'Template %s\n' % template
            for weaponPreference in self.templates[template]['WeaponPreference']:
                tempStr += '\tWeaponPreference = %s\n' % weaponPreference.lower()
            tempStr += 'End\n\n'
        tempStr += '//----------------------------------------------------------------------------\n'
        tempStr += '// skill templates\n'
        tempStr += '//----------------------------------------------------------------------------\n'
        for template in filter(lambda x: self.templates[x]["Type"] == "skill", self.templates):
            tempStr += 'Template %s\n' % template
            for option in self.templates[template]:
                if option != "Type":
                    tempStr += "\t%s = %s\n" % (option, self.templates[template][option])
            tempStr += 'End\n\n'
        tempStr += """\
//----------------------------------------------------------------------------
//
// These are the individual bot profiles, which inherit first from 
// Default and then the specified Template(s), in order
//

"""
        for bot in self.bots:
            tempStr += '%s+%s "%s"\n' % (self.bots[bot]['skillTemplate'], self.bots[bot]['weaponTemplate'], bot)
            tempStr += '\tSkin = %s\n' % self.bots[bot]['skin']
            tempStr += '\tVoicePitch = %s\n' % self.bots[bot]['pitch']
            tempStr += 'End\n\n'
        tempStr += '//----------------------------------------------------------------------------\n'
        tempStr += '// END OF FILE - Conversion by freddukes (-TsX- Pro Noob)\n'
        tempStr += '//----------------------------------------------------------------------------'
        addBots = True
        if ''.join(thisFile.readlines()) != tempStr:
            print "Botprofile.db Updated!!! In need of a map change"
            thisFile.close()
            thisFile = open(self.botprofile, 'w')
            thisFile.writelines(tempStr)
            addBots = False
        thisFile.close()
        return addBots
        
bots = BotManager()

def botCommand():
    arg1 = es.getargv(1).lower()
    if arg1 == "template":
        arg2 = es.getargv(2).lower()
        
        if arg2 == "skill":
            bots.createTemplate("skill", es.getargv(3), int(es.getargv(4)), int(es.getargv(5)), float(es.getargv(6)), es.getargv(7), int(es.getargv(8)) if es.getargv(8) else 90)
            
        elif arg2 == "weapon":
            bots.createTemplate("weapon", es.getargv(3), weaponPreference = map(lambda x: x.strip(), str(es.getargv(4)).split(',') ) )
            
        else:
            raise ValueError, "ERROR: Template type %s is not a valid template type" % arg2
            
    elif arg1 == "create":
        bots.createBot(es.getargv(2), es.getargv(3), es.getargv(4), int(es.getargv(5)) if es.getargv(5) else 1, int(es.getargv(6)) if es.getargv(6) else 90)
        
    elif arg1 == "delete":
        bots.deleteBot(es.getargv(2))
    
    elif arg1 == "say":
        # realbots say <event> <text>
        bots.addSay(es.getargv(2), es.getarv(3))
    else:
        raise ValueError, "ERROR: subcommand %s for command realbots does not exists" % arg1
            
if not es.exists('command', 'realbots'):
    es.regcmd('realbots', 'realbots/botCommand', 'The main command to add real bots.')
    
def forceSay(userid, text):
    if es.isbot(userid):
        if text:
            gamethread.cancelDelayed('bot_say_%s'%userid)
            if text.endswith('|team'):
                # Make the text delay so it seems like the bot is actually taking time to type (between 5-7 letters per second)
                text = text.replace('|team','')
                gamethread.delayedname(random.randint(len(text)/7,len(text)/5), 'bot_say_%s' % userid, es.sexec, (userid, 'say_team', text) )
            else:
                # Make the text delay so it seems like the bot is actually taking time to type (between 5-7 letters per second)
                gamethread.delayedname(random.randint(len(text)/7,len(text)/5), 'bot_say_%s' % userid, es.sexec, (userid, 'say', text) )
        
def checkEvent(eventName, tokens={}):
    if bots.sayEvents.has_key(eventName) and int(es.ServerVar('rb_botTalk')):
        random_number = random.randint(1,100)
        if random_number <= int(bots.sayEvents[eventName]['percentage']):
            return Template(bots.sayEvents[eventName][random.choice(filter(lambda x: x != "percentage", bots.sayEvents[eventName]))]).substitute(tokens)
    return None

dict_options = {
'rb_ping'            : [1,   "Allow bots to have a random ping value?"],
'rb_minPing'         : [25,  "The minimum possible value for the ping of the bots"],
'rb_maxPing'         : [100, "The maximum possible value for the ping of the bots"],
'rb_pingUpdateDelay' : [10,  "The amount of seconds between each ping update"],
'rb_botAmount'       : [4,   "Maximum amount of bots to be in the server"],
'rb_botAutoKick'     : [1,   "Automatically kick bots when a human player joins"],
'rb_botTalk'         : [1,   "Allow bots to reply to certain events? (see bott_speech.ini)"],
'rb_botOnBotTalk'    : [1,   "Allow bots talk to trigger other bots say triggers?"]
}

def load(forced=False):
    """  """
    setBotValue()
    for option in dict_options:
        es.ServerVar(option, dict_options[option][0], dict_options[option][1])
    
    if os.path.isfile(es.getAddonPath('realbots') + '/config.cfg'):
        es.server.queuecmd('es_xmexec ../addons/eventscripts/realbots/config.cfg')
    
    if not forced:
        gamethread.delayed(0.1, load, True)
    
    else:
        addBots = bots.execute()
        if addBots:
            while bots.botCount < int(es.ServerVar('rb_botAmount')):
                bots.addBot()
        else:
            print "Changing map to the current one to reset the bots stats...."
            es.server.queuecmd('changelevel %s'%es.ServerVar('eventscripts_currentmap') )
            
def unload():
    bots.removeAllBots()
    gamethread.cancelDelayed('botPing')
    
def addInitialBots():
    while bots.botCount < int(es.ServerVar('rb_botAmount')):
        bots.addBot()
        
def es_map_start(ev):
    setBotValue()
    bots.updateBotCount()
    if ev == "forced":
        while bots.botCount < int(es.ServerVar('rb_botAmount')):
            bots.addBot()
    else:
        gamethread.delayed(1, es_map_start, "forced")
        
def player_activate(ev):
    if ev['es_steamid'] != "BOT":
        if bots.botCount and int(es.ServerVar('rb_botAutoKick') ):
            count, team = max(map(lambda x: [es.getplayercount(x), x], [2,3] ) )
            botNames = map(lambda x: es.getplayername(x), filter(lambda x: es.isbot(x) and es.getplayerteam(x) == team, es.getUseridList() ) )
            if len(botNames):
                bots.removeBot(random.choice(botNames))
            else:
                bots.removeBot()

def player_disconnect(ev):
    if ev['networkid'] != "BOT" and bots.botCount < int(es.ServerVar('rb_botAmount') ):
        bots.addBot()
    else:
        gamethread.cancelDelayed('bot_say_%s' % ev['userid'])
        
def round_start(ev):
    if bots.botCount > int(es.ServerVar('rb_botAmount') ):
        while bots.botCount > int(es.ServerVar('rb_boutAmount') ):
            count, team = max(map(lambda x: [es.getplayercount(x), x], [2,3] ) )
            botNames = map(lambda x: es.getplayername(x), filter(lambda x: es.isbot(x) and es.getplayerteam(x) == team, es.getUseridList() ) )
            if len(botNames):
                bots.removeBot(random.choice(botNames))
            else:
                bots.removeBot()
    elif 0 < bots.botCount < int(es.ServerVar('rb_botAmount')) and (len(filter(lambda x: not es.isbot(x), es.getUseridList())) - bots.botCount) > int(es.ServerVar('rb_botAmount')):
        """ There are bots and humans (I.E not rb_botAmount yet) but in total, there are more than rb_botAmount players, so something stuffed up happened. """
        while es.getUseridList() > int(es.ServerVar('rb_botAmount')):
            bots.removeBot()
    random_bot = filter(lambda x: es.isbot(x), es.getUseridList() )
    if not len(random_bot):
        return 
    text = checkEvent('roundstart')
    forceSay(random.choice(random_bot), text)
        
def round_end(ev):
    random_bot = filter(lambda x: es.isbot(x), es.getUseridList() )
    if not len(random_bot):
        return
    random_ct = filter(lambda x: es.getplayerteam(x) == 3, random_bot)
    random_t  = filter(lambda x: es.getplayerteam(x) == 2, random_bot)
    text = checkEvent('roundlost')
    forceSay(random.choice(random_ct if ev['winner'] == "2" and len(random_ct) else random_t if len(random_t) else es.getUseridList()), text)
    text = checkEvent('roundwon')
    forceSay(random.choice(random_ct if ev['winner'] == "3" and len(random_ct) else random_t if len(random_t) else es.getUseridList()), text)
        
def player_hurt(ev):
    if ev['es_userteam'] != ev['es_attackerteam']:
        text = checkEvent('hurt', {'victim':ev['es_username'], 'attacker':ev['es_attackername']})
        forceSay(ev['userid'], text)
        text = checkEvent('damaged', {'victim':ev['es_username'], 'attacker' : ev['es_attackername']})
        forceSay(ev['attacker'], text)
    else:
        if ev['userid'] != ev['attacker']:
            text = checkEvent('teamattacked', {'victim' : ev['es_username'], 'attacker' : ev['es_attackername']})
            forceSay(ev['userid'], text)
            text = checkEvent('teamattacker', {'victim' : ev['es_username'], 'attacker' : ev['es_attackername']})
            forceSay(ev['attacker'], text)
                
def player_death(ev):
    if ev['es_userteam'] != ev['es_attackerteam']:
        if int(ev['headshot']):
            text = checkEvent('headshot', {'victim' : ev['es_username'], 'attacker' : ev['es_attackername']})
            forceSay(ev['userid'], text)
            text = checkEvent('headshoted', {'victim' : ev['es_username'], 'attacker' : ev['es_attackername']})
            forceSay(ev['attacker'], text)
            return
        if ev['weapon'] == "knife":
            text = checkEvent('knife', {'victim' : ev['es_username'], 'attacker' : ev['es_attackername']})
            forceSay(ev['userid'], text)
            text = checkEvent('knifed', {'victim' : ev['es_username'], 'attacker' : ev['es_attackername']})
            forceSay(ev['attacker'], text)
            return 
        if ev['weapon'] == "hegrenade":
            text = checkEvent('grenade', {'victim' : ev['es_username'], 'attacker' : ev['es_attackername']})
            forceSay(ev['userid'], text)
            text = checkEvent('grenaded', {'victim' : ev['es_username'], 'attacker' : ev['es_attackername']})
            forceSay(ev['attacker'], text)
            return
        text = checkEvent('death', {'victim':ev['es_username'], 'attacker':ev['es_attackername']})
        forceSay(ev['userid'], text)
        text = checkEvent('kill', {'victim':ev['es_username'], 'attacker' : ev['es_attackername']})
        forceSay(ev['attacker'], text)
    else:
        if ev['userid'] != ev['attacker']:
            text = checkEvent('teamkilled', {'victim' : ev['es_username'], 'attacker' : ev['es_attackername']})
            forceSay(ev['userid'], text)
            text = checkEvent('teamkill', {'victim' : ev['es_username'], 'attacker' : ev['es_attackername']})
            forceSay(ev['attacker'], text)
    
def player_say(ev):
    if ev['es_steamid'] != "BOT" or int(es.ServerVar('rb_botOnBotTalk')):
        if bots.sayEvents.has_key("say"):
            if random.randint(1,100) <= int(bots.sayEvents["say"]['percentage']):
                text_list = filter(lambda x: x != "percentage", bots.sayEvents["say"])
                for text in text_list:
                    if ev['text'].lower() == text:
                        random_bot = filter(lambda x: es.isbot(x) and not x == int(ev['userid']), es.getUseridList() )
                        if not len(random_bot):
                            return
                        forceSay(random.choice(random_bot), random.choice(map(lambda x: x.strip(), bots.sayEvents["say"][text].split(','))))
                        break

def setBotValue():
    es.server.queuecmd('bot_prefix ""')
    es.server.queuecmd('bot_join_after_player 0')
    es.server.queuecmd('bot_defer_to_human 0')
    es.server.queuecmd('bot_chatter "off"')
    es.server.queuecmd('bot_auto_vacate 0')
    es.server.queuecmd('bot_allow_rogues 1')
